'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-e128abd5.js');
require('./_commonjsHelpers-537d719a.js');
const iframeSession = require('./iframeSession-e5f7c7e0.js');

const quickomChatHookCss = "quickom-chat-hook{}";

const QuickomChatHook = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.chatMessage = index.createEvent(this, "chatMessage", 7);
    this.domain = 'https://widget.quickom.com';
    this.memberId = '';
    this.apiKey = '';
    this.iframeElement = null;
    this.iframeMessenger = null;
    this.iframeSession = null;
  }
  getUrl() {
    return `${this.domain}/chat-hook`;
  }
  onIframeRef(el) {
    this.iframeElement = el;
  }
  // private reloadIframe() {
  //   if (this.iframeElement) {
  //     this.iframeElement.src = this.getUrl();
  //   }
  // }
  onLoadIframe() {
    this.iframeMessenger = new iframeSession.IframeMessenger(this.iframeElement);
    this.iframeMessenger.start();
    this.iframeSession = iframeSession.IframeSession.init(this.iframeMessenger);
    this.hookChat();
    this.iframeSession.on('message', this.onChatBoxMessage.bind(this));
  }
  hookChat() {
    if (this.iframeSession && this.memberId && this.apiKey) {
      this.iframeSession.send({
        resource: 'chat',
        method: 'hookChat',
        params: [{ memberId: this.memberId, apiKey: this.apiKey }],
      });
    }
  }
  onChatBoxMessage(data) {
    switch (data.method) {
      case 'receiveMessage':
        this.chatMessage.emit(data.params[0]);
        break;
    }
  }
  render() {
    return index.h("iframe", { onLoad: () => this.onLoadIframe(), ref: el => this.onIframeRef(el), src: this.getUrl(), width: "0", height: "0", frameborder: "0" });
  }
  onChangeMemberId() {
    this.hookChat();
  }
  onChangeApiKey() {
    this.hookChat();
  }
  disconnectedCallback() {
    this.iframeSession.destroy();
    this.iframeMessenger.stop();
    this.iframeMessenger = null;
    this.iframeSession = null;
  }
  static get watchers() { return {
    "memberId": ["onChangeMemberId"],
    "apiKey": ["onChangeApiKey"]
  }; }
};
QuickomChatHook.style = quickomChatHookCss;

exports.quickom_chat_hook = QuickomChatHook;
