import EventEmitter3 from 'eventemitter3';
export default class EventEmitter extends EventEmitter3 {
  constructor() {
    super();
  }
  asObservable() {
    let listeners = [];
    let observable = {
      on: (type, cb) => {
        listeners.push({ type, cb });
        this.on(type, cb);
        return observable;
      },
      once: (type, cb) => {
        listeners.push({ type, cb });
        this.once(type, cb);
        return observable;
      },
      removeListener: (type, cb) => {
        this.removeListener(type, cb);
        return observable;
      },
      off: (type, cb) => {
        this.off(type, cb);
        return observable;
      },
      removeAllListener() {
        listeners.forEach(({ type, cb }) => {
          this.off(type, cb);
        });
        listeners.length = 0;
        return observable;
      },
      unsubscribe() {
        return observable.removeAllListener();
      },
      reEmit(eventEmitter, eventNames) {
        for (let e of eventNames) {
          observable.on(e, (...args) => {
            eventEmitter.emit(e, ...args);
          });
        }
        return observable;
      }
    };
    return observable;
  }
  reEmit(e, eventNames) {
    let observable = e.asObservable();
    for (let e of eventNames) {
      observable.on(e, (...args) => {
        this.emit(e, ...args);
      });
    }
    return observable;
  }
}
